Index: /trunk/detectbarotropicmode.sh
===================================================================
--- /trunk/detectbarotropicmode.sh	(revision 41)
+++ /trunk/detectbarotropicmode.sh	(revision 42)
@@ -3,8 +3,11 @@
 #+
 #
-# NAME
-# ====
-#
-# detectbarotropicmode.sh - build file for detection of barotropic mode
+# =======================
+# detectbarotropicmode.sh 
+# =======================
+#
+# -------------------------------------------
+# build file for detection of barotropic mode
+# -------------------------------------------
 #
 # SYNOPSIS
@@ -92,4 +95,5 @@
  ;;
  *) # other choice
+    echo "eee : unknown option ${1}"
     echo "${usage}"
  ;;
Index: /trunk/geomag_profile.sh
===================================================================
--- /trunk/geomag_profile.sh	(revision 41)
+++ /trunk/geomag_profile.sh	(revision 42)
@@ -2,24 +2,22 @@
 #
 #+
-#
-# NAME
-# ====
-#
-# geomag_profile.sh - define GEOMAG environment
+# =================
+# geomag_profile.sh
+# =================
+#
+# -------------------------
+# define GEOMAG environment
+# -------------------------
 #
 # SYNOPSIS
 # ========
 #
-# Online usage
-#
-# ::
-#
-# $ . geomag_profile.sh -d directory -i indir -o outdir -t tempdir
-#
-# In ${HOME}/.profile, add the following line
-#
-# ::
-#
-# . geomag_profile.sh -d directory  -i indir -o outdir -t tempdir
+# Online usage::
+#
+#  $ . geomag_profile.sh -d directory -i indir -o outdir -t tempdir
+#
+# In ${HOME}/.profile, add the following line::
+#
+#  . geomag_profile.sh -d directory  -i indir -o outdir -t tempdir
 #
 # DESCRIPTION
@@ -41,37 +39,33 @@
 # ========
 #
-# For fplod, on aedon.locean-ipsl.upmc.fr:
-# ::
+# For fplod, on aedon.locean-ipsl.upmc.fr::
 #
 #  $ cd /usr/home/fplod/incas/geomag/geomag_ws
 #  $ . geomag_profile.sh -d /usr/home/fplod/incas/geomag/geomag_ws/ -i ${HOME}/geomag_d/ -o ${HOME}/geomag_d/ -t /usr/temp/${LOGNAME}/log/
 #
-# For reee522 on rhodes.idris.fr:
-# ::
+# For reee522 on rhodes.idris.fr::
 #
 #  $ cd ${HOME}/incas/geomag/geomag_ws/
 #  $ . geomag_profile.sh -d ${HOME}/incas/geomag/geomag_ws/ -i ${HOMEGAYA}/geomag_d/ -o ${HOMEGAYA}/geomag_d/ -t /tmp/${LOGNAME}/log/
 #
-#
-# FILES
-# =====
-#
-# original location
-# ~~~~~~~~~~~~~~~~~
-#
-# /usr/home/fplod/incas/geomag/geomag_ws/geomag_profile.sh sur aedon.locean-ipsl.upmc.fr
+# TODO
+# ====
+#
+# ++ option bavarde
+#
+# ++ machine dependant
+#
+# ++ besoin de posix
+#
+# ++ pas de MANPATH defini par défaut sur zeus
 #
 # EVOLUTIONS
 # ==========
 #
-# ++ option bavarde
-#
-# ++ machine dependant
-#
-# ++ besoin de posix
-#
-# ++ pas de MANPATH defini par déubt sur zeus
-#
 # $Id$
+#
+# - fplod 20100318T073619Z aedon.locean-ipsl.upmc.fr (Darwin)
+#
+#   * unset
 #
 # - reee522 2007-06-14T14:25:00Z rhodes (IRIX64)
@@ -99,4 +93,5 @@
 usage=" Usage : ${command} -d directory -i indir -o outdir -t tempdir"
 #
+set +u
 while [ ! -z "${1}" ] # ++ pb bash
 do
@@ -120,4 +115,5 @@
 
  *) # other choice
+  echo "eee : unknown option ${1}"
   echo "${usage}"
   # nb : no exit because this file should be launched by login process
@@ -126,5 +122,8 @@
  shift # next flag
 done
-
+unset usage
+#
+set -u
+#
 # check for ${directory}
 if [ ! -d ${directory} ]
@@ -151,7 +150,9 @@
 ;;
 esac
+unset system
 #
 GEOMAG=${directory}
 export GEOMAG
+unset directory
 #
 # add GEOMAG tools to PATH
@@ -167,4 +168,5 @@
    echo "${command} : iii : ${GEOMAG}/ already in \${PATH}"
 fi
+unset test_path
 #
 # add GEOMAG manuals to MANPATH
@@ -174,13 +176,15 @@
 if [ ${test_manpath} -ne 0 ]
 then
-   MANPATH=${GEOMAG}/man/:${MANPATH}
+   MANPATH=${GEOMAG}/doc/manuals/man/:${MANPATH}
    export MANPATH
 else
    # option bavarde oui/non pas encore implantée ++
-   echo "${command} : iii : ${GEOMAG}/man/ already in \${MANPATH}"
-fi
+   echo "${command} : iii : ${GEOMAG}/doc/manuals/man/ already in \${MANPATH}"
+fi
+unset test_manpath
 #
 GEOMAG_LOG=${tempdir}
 export GEOMAG_LOG
+unset tempdir
 if [ ! -d ${GEOMAG_LOG} ]
 then
@@ -208,4 +212,5 @@
 GEOMAG_ID=${indir}
 export GEOMAG_ID
+unset indir
 if [ ! -d ${GEOMAG_ID} ]
 then
@@ -222,4 +227,5 @@
 GEOMAG_OD=${outdir}
 export GEOMAG_OD
+unset outdir
 if [ ! -d ${GEOMAG_OD} ]
 then
@@ -240,3 +246,4 @@
 #
 # end
+unset command
 # nb : no exit because this file should be launched by login process
Index: /trunk/getmodelout.sh
===================================================================
--- /trunk/getmodelout.sh	(revision 41)
+++ /trunk/getmodelout.sh	(revision 42)
@@ -2,10 +2,11 @@
 #
 #+
+# ==============
+# getmodelout.sh
+# ==============
 #
-# NAME
-# ====
-#
-# getmodelout.sh - get model data output file in ${GEOMAG_ID}
-#
+# ------------------------------------------
+# get model data output file in ${GEOMAG_ID}
+# ------------------------------------------
 #
 # SYNOPSIS
@@ -24,7 +25,5 @@
 # ========
 #
-#
-# To get DRAKKAR G42 experiment output on grid T points beteween year 9 and 10:
-# ::
+# To get DRAKKAR G42 experiment output on grid T points beteween year 9 and 10::
 #
 #  $ getmodelout.sh -r ORCA025 -exp G42 -g gridT -yearmin 9 -yearmax 10 -o ${GEOMAG_OD}/list_G42
@@ -34,4 +33,9 @@
 #
 # $Id$
+#
+# - fplod 20100318T073947Z aedon.locean-ipsl.upmc.fr (Darwin)
+#
+#   * unset
+#
 # - reee522 2007-11-26T11:21:37Z rhodes (IRIX64)
 #
@@ -71,4 +75,5 @@
  ;;
  *) # other choice
+   echo "eee : unknown option ${1}"
    echo "${usage}"
  ;;
@@ -76,4 +81,5 @@
  shift # next flag
 done
+unset usage
 #
 set -u
@@ -109,4 +115,5 @@
   cyear=`printf "%4.4d" ${iyear}`
   ls ${dirref}/${orcares}/${orcares}-${drakkar_exp}-S/${cyear}/${orcares}-${drakkar_exp}_y${cyear}m??d??_${grid}.nc >> ${listfull}
+  unset cyear
   # ++ calcul taille cf myls dans faq es dods
   # iyear=$(( ${iyear} + 1 )) ++ pas ok sur rhodes
@@ -114,4 +121,9 @@
   iyear=`expr  ${iyear} + 1 `
 done
+unset iyear
+unset dirref
+unset orcares
+unset drakkar_exp
+unset grid
 #
 # print total size of model files
@@ -129,4 +141,5 @@
   echo ${GEOMAG_ID}/`basename ${file}` >> ${list}
 done
+unset listfull
 #
 # end
Index: /trunk/step2_diff.sh
===================================================================
--- /trunk/step2_diff.sh	(revision 41)
+++ /trunk/step2_diff.sh	(revision 42)
@@ -3,9 +3,11 @@
 #+
 #
-# NAME
-# ====
+# =============
+# step2_diff.sh
+# =============
 #
-# step2_diff.sh - launch step2_diff.pro with year argument
-#
+# ------------------------------------------
+# launch step2_diff.pro with year argument
+# ------------------------------------------
 #
 # SYNOPSYS
@@ -19,16 +21,7 @@
 # ========
 #
-# For test on year 1994:
-# ::
+# For test on year 1994::
 #
 #  $ ./step2_diff.sh -y 1994
-#
-# FILES
-# =====
-#
-# original location
-# ~~~~~~~~~~~~~~~~~
-#
-# /usr/home/fplod/incas/geomag/geomag_ws/step2_diff.sh sur aedon.locean-ipsl.upmc.fr
 #
 # EVOLUTIONS
@@ -36,4 +29,8 @@
 #
 # $Id$
+#
+# - fplod 20100318T074009Z aedon.locean-ipsl.upmc.fr (Darwin)
+#
+#   * unset
 #
 # - fplod 2007-08-22T08:50:02Z aedon.locean-ipsl.upmc.fr (Darwin)
@@ -52,4 +49,5 @@
 ;;
 esac
+unset system
 #
 command=$(basename ${0})
@@ -65,4 +63,5 @@
  ;;
  *) # other choice
+  echo "eee : unknown option ${1}"
   echo "${usage}"
   exit 1
@@ -71,4 +70,5 @@
  shift # next flag
 done
+unset usage
 #
 # ++ check year validity
@@ -85,4 +85,6 @@
 EOF
 #
+unset year
+#
 # launch IDL with the sequence
 ${IDL_DIR}/bin/idl < /tmp/${command}${$}.pro